= nng_sleep_aio(3)
//
// Copyright 2020 Staysail Systems, Inc. <info@staysail.tech>
// Copyright 2018 Capitar IT Group BV <info@capitar.com>
//
// This document is supplied under the terms of the MIT License, a
// copy of which should be located in the distribution where this
// file was obtained (LICENSE.txt).  A copy of the license may also be
// found online at https://opensource.org/licenses/MIT.
//

== NAME

nng_sleep_aio - sleep asynchronously

== SYNOPSIS

[source, c]
----
#include <nng/nng.h>

void nng_sleep_aio(nng_duration msec, nng_aio *aio);
----

== DESCRIPTION

The `nng_sleep_aio()` function provides an asynchronous delay mechanism,
causing the callback for _aio_ to be executed after _msec_ milliseconds.
If the sleep finishes completely, the result will always be zero.

NOTE: If a timeout is set on _aio_ using
xref:nng_aio_set_timeout.3.adoc[`nng_aio_set_timeout()`], and it is shorter
than _msec_,
then the sleep will wake up early, with a result code of `NNG_ETIMEDOUT`.

== RETURN VALUES

None.

== ERRORS

None.

== SEE ALSO

[.text-left]
xref:nng_aio_abort.3.adoc[nng_aio_abort(3)],
xref:nng_aio_alloc.3.adoc[nng_aio_alloc(3)],
xref:nng_aio_set_timeout.3.adoc[nng_aio_set_timeout(3)],
xref:nng_strerror.3.adoc[nng_strerror(3)],
xref:nng_aio.5.adoc[nng_aio(5)],
xref:nng_duration.5.adoc[nng_duration(5)],
xref:nng.7.adoc[nng(7)]
